<?php

namespace Commocore\C64Unit\Symlinker\CoreInstallers\Strategy;

use Commocore\C64Unit\Symlinker\Configuration;

class Xa65CoreInstaller implements CoreInstallerInterface
{
    public function getName()
    {
        return Configuration::XA65;
    }

    /**
     * @param string $page
     * @return string
     */
    public function getContent($page)
    {
        return PHP_EOL .
            '; This file is automatically generated by Symlinker' . PHP_EOL . PHP_EOL .
            '#ifdef c64unit_include_definitions' . PHP_EOL .
            '#ifndef c64unit_include_package' . PHP_EOL .
            '#define coreBinaryLocation $' . $page . PHP_EOL .
            '#include "symbols.asm"' . PHP_EOL .
            '#include "macros.asm"' . PHP_EOL .
            '#endif' . PHP_EOL .
            '#endif' . PHP_EOL .
            PHP_EOL .
            '#ifdef c64unit_include_package' . PHP_EOL .
            'c64unit_continuous_block' . PHP_EOL .
            '* = coreBinaryLocation' . PHP_EOL .
            '.dsb (*-c64unit_continuous_block), 0' . PHP_EOL .
            '* = coreBinaryLocation' . PHP_EOL .
            '.bin 0, 0, "../vendor/c64unit-framework/bin/core' . $page . '.bin"' . PHP_EOL .
            '#endif' . PHP_EOL;
    }
}
